<?php

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;
use \Doctrine\ORM\EntityManager;


class VendasHoraHora {

	protected $entityManager;

	public function __construct(EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}

    private function setReportParameters(&$params, &$conditions) {
        $params = array(
            ':DTINI' => isset($conditions['DTINI']) ? $conditions['DTINI'] : null ,
            ':DTFIN' => isset($conditions['DTFIN']) ? $conditions['DTFIN'] : null ,
            ':CDFILIAL' => isset($conditions['CDFILIAL']) ? $conditions['CDFILIAL'] : null ,
            ':TCDFILIAL' => isset($conditions['TCDFILIAL']) ? $conditions['TCDFILIAL'] : null ,
            ':HORAINI' => isset($conditions['HORAINI']) ? $conditions['HORAINI'] : null ,
            ':HORAFIM' => isset($conditions['HORAFIM']) ? $conditions['HORAFIM'] : null ,
            ':MININI' => isset($conditions['MININI']) ? $conditions['MININI'] : null ,
            ':MINFIM' => isset($conditions['MINFIM']) ? $conditions['MINFIM'] : null ,
            ':NRORG' => $conditions['NRORG']
        );
            //':CDLOJA' => isset($conditions['CDLOJA']) ? $conditions['CDLOJA'] : null ,
            //':TCDLOJA' => isset($conditions['TCDLOJA']) ? $conditions['TCDLOJA'] : null ,
    }

    public function getVendasHoraHora($conditions) {
    	$params = [];
        $this->setReportParameters($params, $conditions);
        if($conditions['TIPORELATORIO'] == 'A'){
            return $this->entityManager->getConnection()->fetchAll(self::REL_VENDAS_HORA_HORA, $params);
        }elseif($conditions['TIPORELATORIO'] == 'S'){
            return $this->entityManager->getConnection()->fetchAll(self::REL_VENDAS_HORA_HORA_CONSOLIDADO, $params);
        }
    }

    // query original

    // const REL_VENDAS_HORA_HORA = "
    //   SELECT  T.CDFILIAL||' - '||T.NMFILIAL AS LABELFILIAL, T.CDFILIAL, TO_CHAR(T.DTPEDIDO, 'DD/MM/YYYY') AS DTHRPEDIDO, T.HORA||':00'||' - '||T.HORA||':59' AS DTHRPEDIDOFIM,
    //           SUM(QTPRODVEND) QTPRODVEND, SUM(T.TOTITEM) VRLIQ, SUM(T.TOTITEMOLD) VRTOTVEND
    //      FROM (
    //           SELECT FILICXVEND.NMFILIAL, I.CDFILIAL, I.CDCAIXA, I.QTPRODVEND,
    //                  ((I.QTPRODVEND * ( I.VRUNITVEND + I.VRUNITVENDCL)) + I.VRACRITVEND - (I.VRDESITVEND)) AS TOTITEM,
    //                  ((I.QTPRODVEND * ( I.VRUNITVEND + I.VRUNITVENDCL)) + I.VRACRITVEND ) AS TOTITEMOLD,
    //                  TRUNC(VE.DTVENDA)  AS DTPEDIDO, TO_CHAR(VE.DTVENDA, 'HH24') AS HORA, TO_CHAR(VE.DTVENDA, 'MI') AS MINUTOS
    //             FROM ITEMVENDA I JOIN (
    //                               SELECT FILICXVEND.CDFILIAL, FILICXVEND.CDCAIXA, FILICXVEND.NRORG, FILICXVEND.NMFILIAL,
    //                                       FILICXVEND.IDSITUVENDA, MAX(FILICXVEND.NRSEQVENDA) AS NRMAX, MIN(FILICXVEND.NRSEQVENDA) AS NRMIN
    //                                  FROM (SELECT FILICX.CDFILIAL, FILICX.CDCAIXA, FILICX.NRORG, FILICX.NMFILIAL, V.NRSEQVENDA, V.IDSITUVENDA
    //                                          FROM VENDA V
    //                                  JOIN (SELECT DISTINCT F.CDFILIAL, C.CDCAIXA, F.NRORG, F.NMFILIAL
    //                                          FROM (SELECT CDFILIAL, F.NRORG, F.NMFILIAL
    //                                                  FROM FILIAL F
    //                                                 WHERE (INSTR(:CDFILIAL, CDFILIAL) <> 0)) F, CAIXA C
    //                                         WHERE F.CDFILIAL = C.CDFILIAL
    //                                           AND F.NRORG = C.NRORG
    //                                           AND F.NRORG = :NRORG) FILICX
    //                                   ON V.CDFILIAL = FILICX.CDFILIAL
    //                                   AND V.CDCAIXA = FILICX.CDCAIXA
    //                                   AND V.NRORG = FILICX.NRORG
    //                                 WHERE ((INSTR(:CDFILIAL, V.CDFILIAL) <> 0))
    //                                   AND V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN
    //                                   AND V.NRORG = :NRORG
    //                                   AND V.IDSITUVENDA = 'O'
    //                                 ORDER BY V.NRSEQVENDA) FILICXVEND
    //                                 GROUP BY FILICXVEND.CDFILIAL, FILICXVEND.CDCAIXA, FILICXVEND.NRORG, FILICXVEND.NMFILIAL, FILICXVEND.IDSITUVENDA
    //                               )FILICXVEND
    //               ON I.CDFILIAL = FILICXVEND.CDFILIAL
    //              AND I.CDCAIXA = FILICXVEND.CDCAIXA
    //              AND I.NRORG = FILICXVEND.NRORG
    //             JOIN VENDA VE
    //               ON I.CDFILIAL = VE.CDFILIAL
    //              AND I.CDCAIXA = VE.CDCAIXA
    //              AND I.NRSEQVENDA = VE.NRSEQVENDA
    //              AND I.NRORG = VE.NRORG
    //           WHERE I.NRORG = :NRORG
    //              AND VE.IDSITUVENDA = 'O'
    //              AND TRUNC(VE.DTVENDA) BETWEEN :DTINI AND :DTFIN
    //              AND I.NRSEQVENDA BETWEEN FILICXVEND.NRMIN-500 AND FILICXVEND.NRMAX
    //              AND TO_NUMBER(TO_CHAR(VE.DTVENDA, 'HH24')) BETWEEN TO_NUMBER(:HORAINI) AND TO_NUMBER(:HORAFIM)
    //              AND TO_NUMBER(TO_CHAR(VE.DTVENDA, 'MI')) BETWEEN TO_NUMBER(:MININI) AND TO_NUMBER(:MINFIM)
    //          ) T
    //      GROUP BY T.CDFILIAL, T.NMFILIAL, T.DTPEDIDO, T.HORA, T.HORA
    //      ORDER BY CDFILIAL, DTPEDIDO, HORA
    // ";

    const REL_VENDAS_HORA_HORA =
    "WITH FILICXVEND AS
               (SELECT FILICXVEND.CDFILIAL, FILICXVEND.CDCAIXA, FILICXVEND.NRORG, FILICXVEND.NMFILIAL,
                                         FILICXVEND.IDSITUVENDA, MAX(FILICXVEND.NRSEQVENDA) AS NRMAX, MIN(FILICXVEND.NRSEQVENDA) AS NRMIN
                                    FROM (SELECT FILICX.CDFILIAL, FILICX.CDCAIXA, FILICX.NRORG, FILICX.NMFILIAL, V.NRSEQVENDA, V.IDSITUVENDA
                                            FROM VENDA V
                                    JOIN (SELECT DISTINCT F.CDFILIAL, C.CDCAIXA, F.NRORG, F.NMFILIAL
                                            FROM (SELECT CDFILIAL, F.NRORG, F.NMFILIAL
                                                    FROM FILIAL F
                                                   WHERE (INSTR(:CDFILIAL, CDFILIAL) <> 0)) F, CAIXA C
                                           WHERE F.CDFILIAL = C.CDFILIAL
                                             AND F.NRORG = C.NRORG
                                             AND F.NRORG = :NRORG) FILICX
                                      ON V.CDFILIAL = FILICX.CDFILIAL
                                     AND V.CDCAIXA = FILICX.CDCAIXA
                                     AND V.NRORG = FILICX.NRORG
                                   WHERE ((INSTR(:CDFILIAL, V.CDFILIAL) <> 0))
                                     AND V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN
                                     AND V.NRORG = :NRORG
                                     AND V.IDSITUVENDA = 'O'
                                   ORDER BY V.NRSEQVENDA) FILICXVEND
                                   GROUP BY FILICXVEND.CDFILIAL, FILICXVEND.CDCAIXA, FILICXVEND.NRORG, FILICXVEND.NMFILIAL, FILICXVEND.IDSITUVENDA)

             SELECT  T.CDFILIAL||' - '||T.NMFILIAL AS LABELFILIAL, T.CDFILIAL, TO_CHAR(T.DTPEDIDO, 'DD/MM/YYYY') AS DTHRPEDIDO, T.HORA||':00'||' - '||T.HORA||':59' AS DTHRPEDIDOFIM,
              SUM(QTPRODVEND) QTPRODVEND, SUM(T.TOTITEM) VRLIQ, SUM(T.TOTITEMOLD) VRTOTVEND
               FROM (SELECT VE.NMFILIAL, I.CDFILIAL, I.CDCAIXA, I.QTPRODVEND,
                           ((I.QTPRODVEND * ( I.VRUNITVEND + I.VRUNITVENDCL)) + I.VRACRITVEND - (I.VRDESITVEND)) AS TOTITEM,
                           ((I.QTPRODVEND * ( I.VRUNITVEND + I.VRUNITVENDCL)) + I.VRACRITVEND ) AS TOTITEMOLD, TRUNC(VE.DTVENDA)  AS DTPEDIDO,
                          :DTINI AS INICIAL, :DTFIN AS FIM, TO_CHAR(DTVENDA,'HH24') AS HORA, TO_CHAR(DTVENDA, 'MI') AS MINUTOS
                      FROM ITEMVENDA I, (SELECT VE.*, FILICXVEND.NMFILIAL
                                           FROM VENDA VE, FILICXVEND
                                          WHERE TRUNC(VE.DTVENDA) BETWEEN :DTINI AND :DTFIN
                                            AND VE.CDFILIAL = FILICXVEND.CDFILIAL
                                            AND VE.CDCAIXA = FILICXVEND.CDCAIXA
                                            AND VE.IDSITUVENDA = 'O'
                                            AND VE.NRSEQVENDA BETWEEN FILICXVEND.NRMIN-500 AND FILICXVEND.NRMAX) VE
                     WHERE I.NRORG = :NRORG
                       AND I.CDFILIAL = VE.CDFILIAL
                       AND I.CDCAIXA = VE.CDCAIXA
                       AND I.NRSEQVENDA = VE.NRSEQVENDA
                       AND I.NRORG = VE.NRORG
                       AND TO_NUMBER(TO_CHAR(DTVENDA, 'HH24')) BETWEEN TO_NUMBER(:HORAINI) AND TO_NUMBER(:HORAFIM)
                       AND TO_NUMBER(TO_CHAR(DTVENDA, 'MI')) BETWEEN TO_NUMBER(:MININI) AND TO_NUMBER(:MINFIM)) T
              GROUP BY T.CDFILIAL, T.NMFILIAL, T.HORA, T.HORA, T.DTPEDIDO
              ORDER BY CDFILIAL, HORA
    ";

    //query original

    // const REL_VENDAS_HORA_HORA_CONSOLIDADO = "
    //         SELECT  T.CDFILIAL||' - '||T.NMFILIAL AS LABELFILIAL, T.CDFILIAL, T.INICIAL||' - '||T.FIM AS DTHRPEDIDO, T.HORA||':00'||' - '||T.HORA||':59' AS DTHRPEDIDOFIM,
    //           SUM(QTPRODVEND) QTPRODVEND, SUM(T.TOTITEM) VRTOTVEND
    //      FROM (
    //           SELECT FILICXVEND.NMFILIAL, I.CDFILIAL, I.CDCAIXA, I.QTPRODVEND,
    //                  ((I.QTPRODVEND * ( I.VRUNITVEND + I.VRUNITVENDCL)) + I.VRACRITVEND - (I.VRDESITVEND)) AS TOTITEM,
    //                  ((I.QTPRODVEND * ( I.VRUNITVEND + I.VRUNITVENDCL)) + I.VRACRITVEND ) AS TOTITEMOLD,
    //                 :DTINI AS INICIAL, :DTFIN AS FIM, TO_CHAR(DTHRPEDIDO, 'HH24') AS HORA, TO_CHAR(DTHRPEDIDO, 'MI') AS MINUTOS
    //             FROM ITEMVENDA I JOIN (
    //                               SELECT FILICXVEND.CDFILIAL, FILICXVEND.CDCAIXA, FILICXVEND.NRORG, FILICXVEND.NMFILIAL,
    //                                       FILICXVEND.IDSITUVENDA, MAX(FILICXVEND.NRSEQVENDA) AS NRMAX, MIN(FILICXVEND.NRSEQVENDA) AS NRMIN
    //                                  FROM (SELECT FILICX.CDFILIAL, FILICX.CDCAIXA, FILICX.NRORG, FILICX.NMFILIAL, V.NRSEQVENDA, V.IDSITUVENDA
    //                                          FROM VENDA V
    //                                  JOIN (SELECT DISTINCT F.CDFILIAL, C.CDCAIXA, F.NRORG, F.NMFILIAL
    //                                          FROM (SELECT CDFILIAL, F.NRORG, F.NMFILIAL
    //                                                  FROM FILIAL F
    //                                                 WHERE (INSTR(:CDFILIAL, CDFILIAL) <> 0)) F, CAIXA C
    //                                         WHERE F.CDFILIAL = C.CDFILIAL
    //                                           AND F.NRORG = C.NRORG
    //                                           AND F.NRORG = :NRORG) FILICX
    //                                   ON V.CDFILIAL = FILICX.CDFILIAL
    //                                   AND V.CDCAIXA = FILICX.CDCAIXA
    //                                   AND V.NRORG = FILICX.NRORG
    //                                 WHERE ((INSTR(:CDFILIAL, V.CDFILIAL) <> 0))
    //                                   AND V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN
    //                                   AND V.NRORG = :NRORG
    //                                   AND V.IDSITUVENDA = 'O'
    //                                 ORDER BY V.NRSEQVENDA) FILICXVEND
    //                                 GROUP BY FILICXVEND.CDFILIAL, FILICXVEND.CDCAIXA, FILICXVEND.NRORG, FILICXVEND.NMFILIAL, FILICXVEND.IDSITUVENDA
    //                               )FILICXVEND
    //               ON I.CDFILIAL = FILICXVEND.CDFILIAL
    //              AND I.CDCAIXA = FILICXVEND.CDCAIXA
    //              AND I.NRORG = FILICXVEND.NRORG
    //             JOIN VENDA VE
    //               ON I.CDFILIAL = VE.CDFILIAL
    //              AND I.CDCAIXA = VE.CDCAIXA
    //              AND I.NRSEQVENDA = VE.NRSEQVENDA
    //              AND I.NRORG = VE.NRORG
    //           WHERE I.NRORG = :NRORG
    //              AND VE.IDSITUVENDA = 'O'
    //              AND TRUNC(I.DTHRPEDIDO) BETWEEN :DTINI AND :DTFIN
    //              AND I.NRSEQVENDA BETWEEN FILICXVEND.NRMIN-500 AND FILICXVEND.NRMAX
    //              AND TO_NUMBER(TO_CHAR(DTHRPEDIDO, 'HH24')) BETWEEN TO_NUMBER(:HORAINI) AND TO_NUMBER(:HORAFIM)
    //              AND TO_NUMBER(TO_CHAR(DTHRPEDIDO, 'MI')) BETWEEN TO_NUMBER(:MININI) AND TO_NUMBER(:MINFIM)
    //          ) T
    //  GROUP BY T.CDFILIAL, T.NMFILIAL, T.INICIAL, T.FIM, T.HORA, T.HORA
    //  ORDER BY CDFILIAL, HORA
    // ";

    const REL_VENDAS_HORA_HORA_CONSOLIDADO = "
            WITH FILICXVEND AS
               (SELECT FILICXVEND.CDFILIAL, FILICXVEND.CDCAIXA, FILICXVEND.NRORG, FILICXVEND.NMFILIAL,
                                         FILICXVEND.IDSITUVENDA, MAX(FILICXVEND.NRSEQVENDA) AS NRMAX, MIN(FILICXVEND.NRSEQVENDA) AS NRMIN
                                    FROM (SELECT FILICX.CDFILIAL, FILICX.CDCAIXA, FILICX.NRORG, FILICX.NMFILIAL, V.NRSEQVENDA, V.IDSITUVENDA
                                            FROM VENDA V
                                    JOIN (SELECT DISTINCT F.CDFILIAL, C.CDCAIXA, F.NRORG, F.NMFILIAL
                                            FROM (SELECT CDFILIAL, F.NRORG, F.NMFILIAL
                                                    FROM FILIAL F
                                                   WHERE (INSTR(:CDFILIAL, CDFILIAL) <> 0)) F, CAIXA C
                                           WHERE F.CDFILIAL = C.CDFILIAL
                                             AND F.NRORG = C.NRORG
                                             AND F.NRORG = :NRORG) FILICX
                                      ON V.CDFILIAL = FILICX.CDFILIAL
                                     AND V.CDCAIXA = FILICX.CDCAIXA
                                     AND V.NRORG = FILICX.NRORG
                                   WHERE ((INSTR(:CDFILIAL, V.CDFILIAL) <> 0))
                                     AND V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN
                                     AND V.NRORG = :NRORG
                                     AND V.IDSITUVENDA = 'O'
                                   ORDER BY V.NRSEQVENDA) FILICXVEND
                                   GROUP BY FILICXVEND.CDFILIAL, FILICXVEND.CDCAIXA, FILICXVEND.NRORG, FILICXVEND.NMFILIAL, FILICXVEND.IDSITUVENDA)

             SELECT T.CDFILIAL||' - '||T.NMFILIAL AS LABELFILIAL, T.CDFILIAL, T.INICIAL||' - '||T.FIM AS DTHRPEDIDO,
                    T.HORA||':00'||' - '||T.HORA||':59' AS DTHRPEDIDOFIM,
                    SUM(QTPRODVEND) QTPRODVEND, SUM(T.TOTITEM) VRTOTVEND
               FROM (SELECT VE.NMFILIAL, I.CDFILIAL, I.CDCAIXA, I.QTPRODVEND,
                           ((I.QTPRODVEND * ( I.VRUNITVEND + I.VRUNITVENDCL)) + I.VRACRITVEND - (I.VRDESITVEND)) AS TOTITEM,
                           ((I.QTPRODVEND * ( I.VRUNITVEND + I.VRUNITVENDCL)) + I.VRACRITVEND ) AS TOTITEMOLD,
                          :DTINI AS INICIAL, :DTFIN AS FIM, TO_CHAR(DTVENDA,'HH24') AS HORA, TO_CHAR(DTVENDA, 'MI') AS MINUTOS
                      FROM ITEMVENDA I, (SELECT VE.*, FILICXVEND.NMFILIAL
                                           FROM VENDA VE, FILICXVEND
                                          WHERE TRUNC(VE.DTVENDA) BETWEEN :DTINI AND :DTFIN
                                            AND VE.CDFILIAL = FILICXVEND.CDFILIAL
                                            AND VE.CDCAIXA = FILICXVEND.CDCAIXA
                                            AND VE.IDSITUVENDA = 'O'
                                            AND VE.NRSEQVENDA BETWEEN FILICXVEND.NRMIN-500 AND FILICXVEND.NRMAX) VE
                     WHERE I.NRORG = :NRORG
                       AND I.CDFILIAL = VE.CDFILIAL
                       AND I.CDCAIXA = VE.CDCAIXA
                       AND I.NRSEQVENDA = VE.NRSEQVENDA
                       AND I.NRORG = VE.NRORG
                       AND TO_NUMBER(TO_CHAR(DTVENDA, 'HH24')) BETWEEN TO_NUMBER(:HORAINI) AND TO_NUMBER(:HORAFIM)
                       AND TO_NUMBER(TO_CHAR(DTVENDA, 'MI')) BETWEEN TO_NUMBER(:MININI) AND TO_NUMBER(:MINFIM)) T
              GROUP BY T.CDFILIAL, T.NMFILIAL, T.INICIAL, T.FIM, T.HORA, T.HORA
              ORDER BY CDFILIAL, HORA

    ";
}